// -*- mode:C++ -*-
/* file: ab_ball_filter.h
 */

#ifndef AB_BALL_FILTER_H
#define AB_BALL_FILTER_H

#include "Ab_filter.h"

const int ball_filt_array = 500;

class Ab_ball_filter : public Ab_filter
{
public:
     Ab_ball_filter(float ball_decay = 0.96, float new_alpha = 0.5);

     void smooth (int curr_time, float measured_position,
                  float& smooth_pos, float& smooth_vel);
     void predict (int curr_time, int pred_delay,
                   float& pred_pos, float& pred_vel);
protected:

     int last_pred_dt;
     float last_pred_pos, last_pred_vel;
     float end_vel[ball_filt_array];
     float end_dist[ball_filt_array];
};


#endif // ifndef AB_BALL_FILTER_H
/* end of file*/

