// -*- mode:C++ -*-
// File:   Kickto_Bad_sector_map.cc
// Author: Antti Tikanmki
// Contact:sunday@ee.oulu.fi
// Last c.:3. Jun 1998
#include <Am/Kickto_Bad_sector_map.h>

Kickto_Bad_sector_map::Kickto_Bad_sector_map()
{
     obj_dir= obj_dist= ball_dir= ball_dist=0.0;
     amap.reset();
     amap.set_type(Kick);
     ENLARGED_RAD = Cons2::player_size()+Cons2::ball_size();
     MAX_BALL_MOM = (float)(1.0/Cons2::kick_power_rate())*Cons2::ball_max_spd();
}

// NEW BETTER & FASTER ONE
void Kickto_Bad_sector_map::calculate_map(Vector ball_loc, Vector ball_vel)
{
     float HESARIN_PAKSUUS = 0.1;
     
     reset();
     if(!kicks_calculated) calculate_possible_kicks(ball_loc, ball_vel);
     // if Ball inside player

     if(ball_loc.get_len() < (ENLARGED_RAD + HESARIN_PAKSUUS))
          ball_loc.lengthen(ENLARGED_RAD + HESARIN_PAKSUUS - ball_loc.get_len());

     // calculate sector that player covers
     Vector player_loc(-ball_loc.get_x(), -ball_loc.get_y());
     float half_sector_angle = 0.1 + asin(ENLARGED_RAD / player_loc.get_len());
     assert(half_sector_angle > 0 && half_sector_angle < M_PI);

     // calculate direction limits
     float right_dir = player_loc.get_dir() - half_sector_angle;
     normalize_angle(right_dir);
     float left_dir  = player_loc.get_dir() + half_sector_angle;
     normalize_angle(left_dir);

     // Check the table over case
     int over = 0;
     if(left_dir<right_dir) over = 1;
     
     // Find the match kicks & put 1.0 to place
     if(over)
          for(int row = 0;row < NRows; row++) {
               for(int col = 0;col < NCols; col++) {
                    if(kicks[row][col].dir <= left_dir || kicks[row][col].dir >= right_dir)
                         amap.add_point(row,col,1.0,0);
               }
          }
     else for(int row = 0;row < NRows; row++) {
               for(int col = 0;col < NCols; col++) {
                    if(kicks[row][col].dir <= left_dir && kicks[row][col].dir >= right_dir)
                         amap.add_point(row,col,1.0,0);
               }
          }
}
float Kickto_Bad_sector_map::ENLARGED_RAD;
float Kickto_Bad_sector_map::MAX_BALL_MOM;
float Kickto_Bad_sector_map::MAX_DST;
