// -*- mode:C++ -*-                                     
// File:   Kickto_map.h
// Author: Antti Tikanmki 23.Jan.1997
// Contact:sunday@ee.oulu.fi
#ifndef KICKTO_MAP_H
#define KICKTO_MAP_H
#include <Am/Actionmap.h>
struct Kick_data
{
     float dir;
     float vel;
};

class Kickto_map : public Actionmap
{
protected:
     float ball_dist;
     float ball_dir;
     float ball_spd;
     float ball_vel_dir;
     static float last_kick_time;
     static float MAX_IMP;
     static float TIME_STEP;
     static float KICK_POWER_RATE;
     static float BALL_DECAY;
     static float ANGLE_DIFF_LIMIT;
     
     int NCols;
     int NRows;
     static int kicks_calculated;
     static Kick_data kicks[Polargrid::NRows][Polargrid::NCols];
     
public:
     void calculate_possible_kicks(Vector ball_loc, Vector ball_vel);
     float find_max_vel_to_dir(float dir);
     void print_kicks();
     void set_kicks_calculated(int value){kicks_calculated = value;};
     void calculate_map(Vector ball_loc, Vector ball_vel,
                        Vector obj_loc, Vector obj_vel,  float right_dir, float left_dir);
     void reset();
     Kickto_map();
     Vector mix_vel_after_kick(Vector ball_mix_vel, Vector kick);
     float time2weight(float reach_time);
     float weight2time(float weight);
};
#endif
