// -*- mode:C++ -*-
/* file    : base_model.h
 * includes: class declaration for the Base model
 */

#ifndef _BASE_MODEL_H
#define _BASE_MODEL_H 1

class Base_model {
public:
     Base_model();
     ~Base_model();
     void state(int time, float *spd, float *aspd, float *turned, float *driven);
     float turn_impulse (int time, float curr_spd,float goal_dir);
     float turn_angle(float curr_spd, float impulse);
     
     float drive_impulse (int time, float curr_spd, float goal_spd);
     float new_speed(float curr_spd, float impulse);
     
     void reset ();
     
private:
     float turn_energy;  // energy available for turning
     float drive_energy; // energy available for driving
     int   turn_time;    // time when the turn energy level was updated
     int   drive_time;   // time when the drive energy level was updated
     float spd_at_last_drive; // speed after last dash
};

#endif

// end of file
