// -*- mode:C++ -*-

/* file    : Be_jumpto_defloc.h
 * includes: class declaration for the Movetoball behavior
 */

#ifndef _BE_JUMPTO_DEFLOC_H
#define _BE_JUMPTO_DEFLOC_H 1

class Be_jumpto_defloc;


typedef enum 
{
     NONE, MOVE_CMD_ID, CHANGE_VQ_CMD_ID, SAY_CMD_ID
} SUPP_ID;

struct Supply_cmd
{
    char *text;
    float var1;   // variable 1 of the command
    float var2;   // variable 2 of the command
    SUPP_ID type;  // type of the command
    int valid;
    
};


#include "Module.h"
//#include "Ac_supply.h" // for Supply_cmd structure
#include <Vs/Vs_referee.h>
#include <Ma/Ma_me.h>

class Be_jumpto_defloc:public Module
{
public:
    Be_jumpto_defloc ();
    ~Be_jumpto_defloc ();
    
    void reset(){;};
    void Init(EmptySamba *sambapointer);
    void read(Supply_cmd &to);
    void invalidate_all() { cmd.valid = 0;}
    
protected:
    FLAG   valid_conds ();
    int    transform ();
    
//        Ma_defloc *ma_defloc; *defloc_msig_in;
    Vs_referee *vs_referee; 
    Ma_me *ma_me;
    Ma_defloc *ma_defloc;
    
    Referee_vs referee;
    Me_marker me;
    Defloc_marker defloc;

    Supply_cmd cmd;
};

#endif

/* end of file */
