// -*- mode:C++ -*-
// File: Be_move.h

#ifndef BE_MOVE_H
#define BE_MOVE_H
class Be_move;

enum am_name      {AM_MBALL, AM_AVOID_BALL, AM_AVOID_BALL_FAR, AM_MTEAMMATE, 
                   AM_MOPPONENT, AM_MDEFLOC, GOTO_BALL, GOTO_BALL_NO_OPP_AVOID,
                   GOTO_DEFLOC, GOTO_SPECLOC, GOTO_AVOID_OFFSIDE,GOTO_GOODLOC, 
                   NUMBER_OF_MOVENAMES};
enum marker_types {MA_BALL, MA_ME, MA_TEAMMATES, MA_OPPONENTS, MA_GOAL, 
                   MA_DEFLOC, MA_SPECLOC, MA_OFFSIDE, MA_GOODLOC, 
                   NUMBER_OF_MTYPES};

#include "EmptySamba.h"
#include "Module.h"
#include "Sensor.h"

#include <Ma/Ma_me.h>
#include <Ma/Ma_ball.h>
#include <Ma/Ma_defloc.h>
#include <Ma/Ma_opponent.h>
#include <Ma/Ma_teammate.h>
#include <Ma/Ma_special_loc.h> 
#include <Ma/Ma_offside.h>

#include <Am/Moveto_maps.h>

//#define BE_MOVE_AM_SAVE

class Be_move:public Module
{
public:
    Be_move();
    ~Be_move();
    void Init(EmptySamba *sambapointer);

    Moveto_map *read(am_name name);
    
protected:

    Ma_ball *ma_ball;
    Ma_me *ma_me;
    Ma_defloc *ma_defloc;
    Ma_special_loc *ma_specloc;
    Ma_opponent *ma_opponent;
    Ma_teammate *ma_teammate;
    Ma_offside *ma_offside;
    
    
    Me_marker me;
    Ball_marker ball;
    Defloc_marker defloc;
    All_players opponents;
    All_players teammates;     
    Special_loc specloc;
    Offside_marker offside;
    
    Moveto_Ball_map ballmap;
    Moveto_Avoid_ball_map avoidballmap;
    Moveto_Avoid_ball_far_map avoidballfarmap;
    Moveto_Player_map teammatemap[MAX_SEEN_PLAYERS];
    Moveto_Player_map opponentmap[MAX_SEEN_PLAYERS];
    Moveto_Player_map all_teammatesmap;
    Moveto_Player_map all_opponentsmap;
    Moveto_Defloc_map deflocmap;
    Moveto_Location_map gotospecloc;
    Moveto_map gotoball;     
    Moveto_map gotoball_no_opp_avoid;
    Moveto_map gotodefloc;
    Moveto_Location_map gotoavoidoffside;
    
    // Flags for calculated maps, readed markers
    int calculated[NUMBER_OF_MOVENAMES];
    int marker_flag[NUMBER_OF_MTYPES];
    Moveto_map *maps[NUMBER_OF_MOVENAMES];
    
    int transform();
    void invalidate_all();
    int must_calc_teammate(int player_no);    
    int must_calc_opponent(int player_no);
    
#ifdef BE_MOVE_AM_SAVE
    ofstream am_save_out;
#endif
};

#endif
