// -*- mode:C++ -*-
#ifndef CONS2_H
#define CONS2_H
#include "icomm.h"
#include "fieldobject.h"
#include "Const.h"

class Cons2:public Const
{
public:
     Cons2(int doit = 1);
          
// there is methods of two kinds:
//
// void         const_name(type &a, type &b) and
// const_type   const_name()
//
     static void set_uniform_number(int unum);
    
#ifdef TEST_SAMBA
     static int debug_level()        { if(debug_plr) return d_level; return 0;        }
     static int debug_level_startup(){ if(debug_plr) return d_level_startup; return 0;}
     static int debug_level_exit()   { if(debug_plr) return d_level_exit; return 0;   }
#endif //TEST_SAMBA
     // the next comments are for the next four functions
     // input:  unum (range is 1-11)
     // output: coordinate (x or y) of defence or attack location of the 
     //         player whose unum is inputted
     static float def_x(int unum){return def_coords[unum-1][0]; }
     static float def_y(int unum){return def_coords[unum-1][1]; }
     static float att_x(int unum){return att_coords[unum-1][0]; }
     static float att_y(int unum){return att_coords[unum-1][1]; }
          
     // the next comments are for the next four functions
     // input:  void 
     // output: coordinate (x or y) of the players defence or attack location
     static float def_x(){return def_coords[const_me_unum-1][0]; }
     static float def_y(){return def_coords[const_me_unum-1][1]; }
     static float att_x(){return att_coords[const_me_unum-1][0]; }
     static float att_y(){return att_coords[const_me_unum-1][1]; }
          
     static int delay(){ return system_delay; }
     void update_delay(int new_delay) { system_delay = new_delay; }
     static char side_char(){ return side; }
     void set_side_char(char side_char){ side = side_char; }
    
     static int goalie_catch_interval(){ return goalie_catch_ban_cycle;}
    
     static float cer_factor(){ return certainty_factor; }
     static float player_max_spd(){ return const_player_max_spd; }
     // ACTIONMAP:
     static float time_step(){return amap_time_step;}
     static float sidekick_wgt(){return amap_sidekick_wgt;}
     static float last_kick_time(){return amap_last_kick_time;}
     static float ball_near_speed(){return amap_ball_near_speed;}
     static float kick_near_wgt(){return amap_kick_near_wgt;}
     static float min_reach_time(){return amap_min_reach_time;}
     static float max_reach_time(){return amap_max_reach_time;}
     static float max_opp_inv_time(){return amap_max_opp_inv_time;}
     static float min_defloc_dst(){return amap_min_defloc_dst;}
     static float max_defloc_dst(){return amap_max_defloc_dst;}
     static float pass_end_spd(){return amap_pass_end_speed;}
     static int projectmaps() { return amap_project_maps; }
     static float max_team_inv_time(){return amap_max_team_inv_time;}
     static float estimated_opp_spd(){return amap_estimated_opp_spd;}
    
  // NEW 170898 by AT:
     static float opp_reaction_time(){return amap_opp_reaction_time;};
     static float far_sector(){return amap_far_sector;};
     static float angle_diff_limit() {return amap_angle_diff_limit;}

    static void set_visual_angle(ViewAngle va){ view_angle = va; }
    static ViewAngle get_visual_angle(){ return view_angle; }
    static float visual_angle(){ 
        if(view_angle== VA_Narrow) return 0.25*M_PI;
        else if(view_angle== VA_Normal) return 0.5*M_PI;
        else if(view_angle== VA_Wide) return M_PI;
        
        cerr << __FILE__ << __LINE__ << endl;
        exit(1);
    }
#ifdef VIS
    static int Visual_local;
    static int Visual_execute;
    static int Visual_opponents;
    static int Visual_teammates;
    static int Visual_ball;
    static int Visual_heading;
    static int Visual_exec_loc;
    static int Visual_exec_heading;
    static int Visual_opp_goal;
    static int Visual_own_goal;
    static int Visual_goal_flags;
    static int Visual_border_flags;
    static int Visual_lines;
    static int Visual_defloc;
    static int Visual_special_loc;
    static int Visual_pos_calc_objects;
#endif //VIS
protected:
    virtual int read_config_file();
    
#ifdef TEST_SAMBA
    static int debug_plr;
#endif //TEST_SAMBA
    static char side;
    static int system_delay;
    static float certainty_factor;
    static int goalie_catch_ban_cycle;
    
    static float def_coords[11][2];
    static float att_coords[11][2];
    static float theor_max_robot_speed;
    
    static ViewAngle view_angle;
    
// TST ALKAA ACTIONMAP
    static float amap_time_step;
    static float amap_sidekick_wgt;
    static float amap_last_kick_time;
    static float amap_ball_near_speed;
    static float amap_kick_near_wgt;
    static float amap_min_reach_time;
    static float amap_max_reach_time;
    static float amap_max_opp_inv_time;
    static float amap_min_defloc_dst;
    static float amap_max_defloc_dst;
    static float amap_pass_end_speed;
    static int amap_project_maps;
    static float amap_max_team_inv_time;
    static float amap_estimated_opp_spd;
// NEW 170898 by AT
    static float amap_opp_reaction_time;
    static float amap_far_sector;
    static float amap_angle_diff_limit;
};

     
     
#endif // CONS2_H
