// -*- mode:C++ -*-
#ifndef CONST_H
#define CONST_H
#include "icomm.h"

enum BOOL {FALSE, TRUE} ;



// name of objects
const char OBJ_NAMES[6][9] = { "player\0 ",
                              "flag\0   ",
                              "line\0   ",
                              "ball\0   ",
                              "goal\0   ",
                              "player\0 " };
enum  FIELDOBJECTS          { OBJ_PLAYER,  OBJ_FLAG, OBJ_LINE, OBJ_BALL, OBJ_GOAL, OBJ_OPPONENT,
                              OBJ_SOMEOPPONENT, OBJ_FRIEND, OBJ_SOMEFRIEND, OBJ_NEARBY_FLAG};

enum LINETYPES { LEFT, CENTER, RIGHT, TOP, BOTTOM };
const char LINECHARS[5] = { 'l', 'c', 'r', 't', 'b' };


const int MAX_SEEN_PLAYERS = 21; // 10 teammates + 11 opponents


// number of different objects on the field
const int NFRIENDS = 11, NUKFRIENDS = 10, NOPPS = 11, NUKOPPS = 11,
          NUNKNOWNS = MAX_SEEN_PLAYERS, NFLAGS = 53, NGOALS = 2, NLINES = 5;


//FLAGTYPES names all the flags, flags must be ordered from left to right
// and from top to bottom
enum FLAGTYPES { 
     TL_50 = 0,TL_40,TL_30,TL_20,TL_10, T_0, TR_10, TR_20, TR_30, TR_40, TR_50,
     LT, CT, RT,
     LT_30, RT_30,
     LT_20, PLT, PRT, RT_20, 
     GLT, LT_10, RT_10, GRT,
     L_0, PLC, C, PRC, R_0,
     GLB, LB_10, RB_10, GRB,
     LB_20, PLB, PRB, RB_20,
     LB_30, RB_30,
     LB, CB, RB,
     BL_50, BL_40, BL_30, BL_20, BL_10, B_0, BR_10, BR_20, BR_30, BR_40, BR_50,
     ERROR
};


const float GOAL_COORDS[2][2] = { { -52.5, 0.0 }, { 52.5, 0.0 } };


const int GOAL_KEEPER_UNUM = 1;
const int LIBERO_UNUM      = 2;
const int DEF1_UNUM        = 3;
const int MIDDLE1_UNUM     = 4;
const int OFF1_UNUM        = 5;
const int DEF2_UNUM        = 6;
const int MIDDLE2_UNUM     = 7;
const int OFF2_UNUM        = 8;
const int DEF3_UNUM        = 9;
const int MIDDLE3_UNUM     = 10;
const int OFF3_UNUM        = 11;

const float MIN_X = -52.5;
const float MAX_X = 52.5;
const float MIN_Y = -34.0;
const float MAX_Y = 34.0;
const float GOAL_WIDTH = 14.02;

const int MAX_DASH_IMP = 100;
const int MAX_KICK_IMP = 100;

class Const
{
public:
     Const(int doit = 1);
     static void set_uniform_number(int unum){ const_me_unum = unum; };
     
     static void flag_coords(FLAGTYPES flag, float &x, float &y);

     static int debug_level(){ return d_level; }
     static int debug_level_startup()      { return d_level_startup;      }
     static int debug_level_exit()         { return d_level_exit;         }
     
     // player physics
     static float player_decay()   { return const_player_decay;    }
     // max_speed is limited by the server
     static float player_spd_limit() { return const_player_max_spd;  }
     static float player_rand()    { return const_player_rand;     }
     static float player_size()    { return const_player_size;     }
     static float player_weight()  { return const_player_weight;   }
     static float dash_power_rate(){ return const_dash_power_rate; }
     
     // ball physics
     static float ball_decay()     { return const_ball_decay;      }
     static float ball_max_spd()   { return const_ball_max_spd;    }
     static float ball_rand()      { return const_ball_rand;       }
     static float ball_size()      { return const_ball_size;       }
     static float ball_weight()    { return const_ball_weight;     }
     static float kick_max_dist()  { return const_kick_max_dist;   }
     static float kick_power_rate(){ return const_kick_power_rate; }
     
     static float goal_width(){ return const_goal_width; }
     
     static void set_introduction_on(){ const_introduction = 1;return;}
     static int introduction() { return const_introduction; }
    
            

     static char* modulename(ID);
     
     static int me_unum(){ return const_me_unum; }
     
protected:
     virtual int read_config_file();
     void init_flag_coords();
          
     int read_IDs_from_icomm_h();
     static char ID_strings[LAST_ID+1+2][40]; // varan vuoksi 2 liikaa!
     
     // debugging options
     static int d_level;
     static int d_level_startup;
     static int d_level_exit;

     // field constants
     static float const_flag_coords[NFLAGS][2];
     static float const_goal_width;
     
     // player physics constants
     static float const_player_decay, const_player_max_spd, const_player_rand, 
          const_player_size, const_player_weight;
     static float const_dash_power_rate;
     
     // ball physics constants
     static float const_ball_decay, const_ball_max_spd, const_ball_rand, 
          const_ball_size, const_ball_weight;
     static float const_kick_max_dist, const_kick_power_rate;
     
     static int const_me_unum;
     static int const_introduction;
    
};

     
     
#endif // CONST_H

