#include <iostream.h>
#include "Vector.h"

Vector::Vector(float new_x,float new_y){  // constructor nollaa tilanteen
     set_xy(new_x,new_y);
}

Vector::Vector(){ 
  x = 0;
  y = 0;
  dir = 0;
  len = 0;
}

void Vector::set_xy(float new_x,float new_y)
{
     x = new_x;
     y = new_y;

     if(fabs(x)<0.00000001) dir = (y<0?-M_PI/2.0:M_PI/2.0);
     else{
          dir = atan( y / x );
          if(x < 0) dir += M_PI;
     }
     normalize();
     len = sqrt(x*x+y*y);
}


void Vector::set_dir_len(float new_dir,float new_len)
{ 
     len = new_len;
     dir = new_dir;
     normalize();
     
     x = cos(dir)*len;
     y = sin(dir)*len;
}

void Vector::lengthen(float value)
{
     float new_len = len + value;
     if(fabs(len) > 0.00001){
          x *= new_len/len;  // = cos(dir)*new_len;
          y *= new_len/len;  // = sin(dir)*new_len;
     } else {
          x = cos(dir)*new_len;
          y = sin(dir)*new_len;
     }
     
     len = new_len;
}


void Vector::turn(float alfa){
  float vx = x,
       vy = y;
  float sini = sin(alfa);
  float kosini = cos(alfa);

  x=kosini * vx - sini * vy;
  y=sini * vx + kosini * vy;
  dir += alfa;
  normalize();
}

void Vector::normalize()
{
     while(dir > M_PI) dir -= 2*M_PI;
     while(dir < -M_PI) dir += 2*M_PI;
}

float Vector::normalize(float& angle)
{
     while(angle > M_PI) angle -= 2*M_PI;
     while(angle < -M_PI) angle += 2*M_PI;
     return angle;
}

float Vector::angle_from(const Vector& v)
{
     float angle = dir - v.dir;
     return normalize(angle);
}

float Vector::angle_to(const Vector& v)
{
     return -angle_from(v);
}

void Vector::err_print_xy()
{
    cerr << "x: " << x << " y: " << y ;
}

void Vector::err_print_dir_len()
{
    cerr << "dir: " << dir << " len: " << len;
}
void Vector::print_xy()
{
    cout << "x: " << x << " y: " << y ;
}

void Vector::print_dir_len()
{
    cout << "dir: " << dir << " len: " << len;
}
void Vector::fprint_xy(ofstream &file)
{
    file << x << " " << y ;
}

void Vector::fprint_dir_len(ofstream &file)
{
    file << dir << " " << len;
}


Vector operator*(float r,const Vector& v) // vektorin kertominen reaaliluvulla
{
     Vector u = v;
     u.x *= r;
     u.y *= r;
     u.len *= r;
     
/*     u.x = v.x * r;
     u.y = v.y * r;
     u.len = v.len * r;
     u.dir = v.dir; */
     return u;
}

Vector operator/(const Vector& v,float r) // vektorin jakaminen reaaliluvulla
{
     Vector u = v;
     u.x /= r;
     u.y /= r;
     u.len /= r;
     return u;
}

Vector operator +(const Vector& v,const Vector& w) // pluslasku
{
  Vector u(v.x+w.x,v.y+w.y);
  return u;
}

Vector operator -(const Vector& v,const Vector& w) // miinuslasku
{
  Vector u(v.x-w.x, v.y-w.y);
  return u;
}

Vector operator -(const Vector& v)
{
  Vector u = v;
  u.x = -u.x;
  u.y = -u.y;
  u.len = u.len;
  u.dir = M_PI + u.dir;
  u.normalize();
  //set(-v.get_x(),-v.get_y());
  return u;
}

float operator *(const Vector& v,const Vector& w) // ristitulo
{
  return v.get_x()*w.get_y() - w.get_x()*v.get_y();
}

float operator ,(const Vector& v,const Vector& w) // pistetulo
{
    return (v.x*w.x+v.y*w.y)/(v.len*w.len);
}

int operator==(const Vector&v, const Vector &w)
{
    if( fabs(v.len-w.len) < 0.000001 &&
        fabs(v.dir-w.dir) < 0.000001 ) return 1;
    return 0;
}


/*
static double vektorien_kulma(Vector a,Vector b){
     double ristitulo,pistetulo,temp;
     ristitulo=a*b;
     pistetulo=(a,b);
     if(a.get_l()==0.0 || b.get_l()==0.0) return 999.0;
     pistetulo/=(a.get_l()*b.get_l()); // cos(alfa)=pistetulo/(a:n pit*b:n pit)
     if(fabs(pistetulo)>1.0)
          return 0.0;
     temp=acos(pistetulo);
     if(ristitulo<0) return -temp;
     else return temp;
}*/
