// -*- mode:C++ -*-                                     
// File:   Vs_referee.h                             
// Author: Jussi Pajala 23.6.1997,  jussip@tks.oulu.fi   
//
// this file declares class of the ball marker

#ifndef VS_REFEREE_H
#define VS_REFEREE_H

enum GAME_STATES { play_on,
                   opp_kick_off, team_kick_off,       // aloitus
                   opp_kick_in, team_kick_in,         // sivurajaheitto
                   opp_corner_kick, team_corner_kick, // kulmapotku
                   opp_goal_kick, team_goal_kick,     // maalipotku
                   opp_free_kick, team_free_kick,     // vapaapotku
                   opp_offside, team_offside,         // paitsio
                   opp_goalie_catch, team_goalie_catch,// maalivahdilla pallo
                   before_kick_off,                   // ennen aloitusta
                   after_goal,                        // heti maalin jlkeen
                   time_over                          // peli loppunut
};

enum GAME_HALFS { first_half, second_half, time_extended };


struct Referee_vs
{
    GAME_STATES game_state;
    GAME_HALFS game_half;
    
    int game_state_changed;
    
    int team_goals;
    int opp_goals;
    int time_running; // IMPORTANT!!!!
    //                   If time is not running, player behavior becomes 
    //                   unstable because we need time to approximate delays.
    //                   time_running must be zero to get rid of unstable
    //                   behavior!!
    int valid;
};

#include "Module.h"
#include "Ab_filter.h"
#include "Sensor.h"
#include "fieldobject.h"
//#include <fstream.h>

class Vs_referee:public Module
{
public:
    Vs_referee();
    ~Vs_referee();
    void Init(EmptySamba *sambapointer);
    
    int game_is_over();
    
    virtual void reset(){ ;};  // do nothing in reset!!
    void read(Referee_vs &to);
    void invalidate_all();
    
protected:
//    FLAG      valid_conds();  // used in Module::execute()
    int       transform();      // called by Module::execute()
    
    void      analyze_message(Audioinfo& message);

    Sensor *sensor; // audio_ssig_in sensr_ssig_in
    
    Audioinfo messages[MAX_HEARD_MSG];
    Referee_vs referee_state;
    
    int n_msg, msg_time;
    ID msg_id;
    
    char side_char;
    
     void set_buffer_pointers();  // goes through incoming bufferlist and connects
};

#endif
