/* File    : cfg.h
 * Includes: Declarations for configuration file processing.
 *
 * Configuration file is read each time a program is started.
 * By placing a parameter in the configuration file, the
 * value of the parameter can be changed without recompiling
 * the program.
 *
 * When you want to add a variable in configuration file:
 * 1) Add it in configuration file (e.g. pure.cfg)
 * 3) After executing cfg_read(), read the value by calling
 *    cfg_get ()
 */

#include <stdio.h>
//#include <string.h>

extern FILE *cfg_open (char *file);
extern void cfg_read (FILE *fp);
extern void cfg_close (FILE *fp);
extern int cfg_get (char *str, float *value);
extern int cfg_find (char *str);

/* end of file
 */
