// -*- mode:C++ -*-                                     
/* File    : decls.h
 * Includes: include file needed by several modules
 */

//#include <LEDA/basic.h>
//#include <LEDA/string.h>
//#include <LEDA/window.h>

#include <stdlib.h>
#include <stdio.h>
#include <iostream.h>
#include <math.h>
#include <assert.h>
//#include "format.h"
#include "trace.h"
#include "tools.h"
//#include "cfg.h"
#include "icomm.h"
#include "Cons2.h"

/* ABBREVIATIONS
 * data structures:
 * ac = actuator, ar = arbiter, be = behavior, 
 * bu = buffer (signal+state), in = interface (actuator/sensor), 
 * ma = marker, si = signal (what is sent), se = sensor, 
 * th = thread, pr = process
 *
 * thread names:
 * cs = control system, ri = robot interface, tracer = tracing 
 * system, ui = user interface
 *
 * module names:
 * ac_base = actuator base, ac_kick = actuator kick, 
 * be_ktog = behavior kicktogoal, be_la = behavior lookaround, 
 * be_mtob = behavior movetoball, be_ttog = behavior turntogoal,
 * se_obj = sensor object
 * 
 * signal/marker names:
 * smo = self motion of the robot, obj_ste = object state signal,
 * ball_ste = ball state signal, goal_ste = goal state signal, 
 * motion_cmd = motion command, kick_cmd = kick command
 *
 * variables:
 * acc = accuracy, cer = certainty, dir = direction, flg = flag,
 * sta = state, len = length, li = line, pnt = point, ti = time,
 * vec = vector, vel = velocity, a = array, c = char, f = float,
 * i = integer, p = pointer, s = structure
 */

/* Signal certainty [0,1] is set by the producer based 
 * on the available data.

 CERTAINTY of an object is < 0 when there is new sensor information, but this object
 is not visible. This feature makes it possible to decide if some object should be looked for



 */


/* eof */






