#include <iostream.h>
#include <fstream.h>
#include <strstream.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <unistd.h>
#include <signal.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
//#include <LEDA/basic.h>


#include "fieldobject.h"

void FieldObject::set_all(int time, int n_arguments, float dist,int dir, 
                          float d_dist, int d_dir)
{
     validate(time); // update validation time
     
     D_dir = d_dir;
     D_dist = d_dist;
     Dir = dir;
     Dist = dist;

     switch(n_arguments){
          // if number of arguments is 1, all except Dir are set to zero.
          // if n_arguments is 2 D_dist and D_dir are set to zero.
          // if it's 3 only D_dir is set to zero
     case 1: cout << "Warning: Only Dir in visual info!!! " << __FILE__ << " line: " << __LINE__ << endl;
          Dir = (int)dist;
          Dist = 0.0;
     case 2: D_dist = 0.0;
     case 3: D_dir = 0;
     default :break;
     }
}

int Flag::get_index(char* arg1, char* arg2, char* arg3) 
{
     FLAGTYPES flag = ERROR;

     switch(arg1[0]){
     case 'p': 
          switch(arg2[0]){
          case 'l': 
               switch(arg3[0]){
               case 't': flag = PLT; break;
               case 'c': flag = PLC; break;
               case 'b': flag = PLB; break;
               } 
               break;
          case 'r':
               switch(arg3[0]){
               case 't': flag = PRT; break;
               case 'c': flag = PRC; break;
               case 'b': flag = PRB; break;
               } 
               break;
          } break;
     case 't':
          switch(arg2[0]){
          case 'l': 
               switch(arg3[0]){
               case '5': flag = TL_50; break;
               case '4': flag = TL_40; break;
               case '3': flag = TL_30; break;
               case '2': flag = TL_20; break;
               case '1': flag = TL_10; break;
               } 
               break;
          case '0': flag = T_0; break;
          case 'r':
               switch(arg3[0]){
               case '5': flag = TR_50; break;
               case '4': flag = TR_40; break;
               case '3': flag = TR_30; break;
               case '2': flag = TR_20; break;
               case '1': flag = TR_10; break;
               } 
               break;
          } 
          break;
     case 'b':
          switch(arg2[0]){
          case 'l': 
               switch(arg3[0]){
               case '5': flag = BL_50; break;
               case '4': flag = BL_40; break;
               case '3': flag = BL_30; break;
               case '2': flag = BL_20; break;
               case '1': flag = BL_10; break;
               } 
               break;
          case '0': flag = B_0; break;
          case 'r':
               switch(arg3[0]){
               case '5': flag = BR_50; break;
               case '4': flag = BR_40; break;
               case '3': flag = BR_30; break;
               case '2': flag = BR_20; break;
               case '1': flag = BR_10; break;
               } 
               break;
          } 
          break;
     case 'l':
          switch(arg2[0]){
          case 't':
               switch(arg3[0]){
               case '\0': flag = LT;break;
               case '3': flag = LT_30;break;
               case '2': flag = LT_20;break;
               case '1': flag = LT_10;break;
               }
               break;
          case 'b':
               switch(arg3[0]){
               case '\0': flag = LB;break;
               case '3': flag = LB_30;break;
               case '2': flag = LB_20;break;
               case '1': flag = LB_10;break;
               }
               break;
          case '0': flag = L_0;break;
          }
          break;
     case 'r':
          switch(arg2[0]){
          case 't':
               switch(arg3[0]){
               case '\0': flag = RT;break;
               case '3': flag = RT_30;break;
               case '2': flag = RT_20;break;
               case '1': flag = RT_10;break;
               }
               break;
          case 'b':
               switch(arg3[0]){
               case '\0': flag = RB;break;
               case '3': flag = RB_30;break;
               case '2': flag = RB_20;break;
               case '1': flag = RB_10;break;
               }
               break;
          case '0': flag = R_0;break;
          }
          break;
     case 'g':
          switch(arg2[0]){
          case 'r':
               switch(arg3[0]){
               case 't': flag = GRT;break;
               case 'b': flag = GRB;break;
               }
               break;
          case 'l':
               switch(arg3[0]){
               case 't': flag = GLT;break;
               case 'b': flag = GLB;break;
               }
               break;
          }
          break;
     case 'c': 
          switch(arg2[0]){
          case 'b': flag = CB;break;
          case 't': flag = CT;break;
          case '\0': flag = C;break;
          }
          break;
     }
     if(flag == ERROR){ 
          cerr << "Flag is not identified: "<< arg1 << arg2 
               << arg3 << endl <<__FILE__<<" "<< __LINE__ << endl;
          exit(1);
     }
     return (int)flag;
     
     cerr << "Not functioning right!!!" << endl 
          << __FILE__ << "  " << __LINE__ << endl;
     exit(1);
}

          
          


void Flag::init(int arrayindex)
{
     flagtype = (FLAGTYPES)arrayindex;
     Const::flag_coords(flagtype,x,y);
     if(x < -70 || x > 70 || y < -40 || y > 40)
          cerr << "Invalid flag coordinate!!!" << endl
               << __FILE__ << " " << __LINE__ << endl;
     
     
     /*x = FLAG_COORDS[arrayindex][0];
       y = FLAG_COORDS[arrayindex][1];*/
}


int Line::get_robot_angle()
{
     switch(linetype){
     case LEFT: if (Dir < 0) return 270+Dir;
          return 90+Dir;
     case RIGHT: if(Dir <0) return 90+Dir;
          return 270+Dir;
     case TOP: if(Dir < 0) return 180+Dir;
          return Dir;
     case BOTTOM: if(Dir <0) return 360+Dir;
          return 180+Dir;
     case CENTER: cerr << " Center line visible, never seen it before."
                       << "Fieldobject.cpp line" << __LINE__ << endl;
          exit(1);
     }
     return -1;
}

void Player::set_all(int time, int n_arguments, float dist,int dir, 
                          float d_dist, int d_dir)
{
    ((FieldObject*)this)->set_all(time, n_arguments, dist,dir, 
                                d_dist, d_dir);
}


void Player::set_all(int time, int n_arguments, float dist,int dir, 
                          float d_dist, int d_dir, int head)
{
     validate(time); // update validation time
     
     D_dir = d_dir;
     D_dist = d_dist;
     Dir = dir;
     Dist = dist;
     heading = head;
     
     switch(n_arguments){
          // if number of arguments is 1, all except Dir are set to zero.
          // if n_arguments is 2 D_dist and D_dir are set to zero.
          // if it's 3 only D_dir is set to zero
     case 1: cout << "Warning: Only Dir in visual info!!! " << __FILE__ << " line: " << __LINE__ << endl;
          Dir = (int)dist;
          Dist = 0.0;
     case 2: D_dist  = 0.0;
     case 3: D_dir   = 0;
     case 4: heading = 0;
     default :break;
     }
}
