// file : main.cc
#include <unistd.h>
#include <pthread.h>
#include <iostream.h>
#include <fstream.h>
#include <signal.h>

#include <sys/utsname.h>

#include "decls.h"
#include "Samba.h"

#include "interface.h"
#include "Vector.h"
#include "Cons2.h"

Cons2 constants;
Interface interface;

main (int argc, char *argv[])
{
    cout << "Starting"<<endl;
    
    struct utsname machine;
    uname(&machine);
    cout << "[" << machine.nodename << "] " ;
    

     int quit_cnt = 5;

     /* initialize trace */
     trc_init_all ();

     if(!(interface.init(argc, argv))){
          cerr << "Interface initialization failed! "
               << __FILE__ << " " << __LINE__ << endl;
          exit(-1);
     }
     
     if(Cons2::debug_level_startup()) cerr << "Now creating Samba object." << endl;
     Samba samba;
     int tick_counter = 0;
     
     //
     // CONTROL SOFTWARE EXECUTION STARTS HERE!!!!
     // 
#ifndef NOPRINTS
     cout << "Executing..." << endl;
#endif
     while (quit_cnt) {
          interface.tick();
          samba.tick ();
          tick_counter ++;
          
          if( samba.state() == QUIT_SOCCER ){
               if(Cons2::debug_level_exit()) 
                    cerr << "resetting samba" << endl;
               samba.reset ();
               quit_cnt--;
               if(Cons2::debug_level_exit()) 
                    cerr << "quit " << quit_cnt  << endl;
               interface.quit();
          }
          
     }
     if(Cons2::debug_level_exit()) printf ("exiting...\n");
}

/* end of file */

