#include "decls.h"
#include <iostream.h>
#include <unistd.h>
#include <signal.h>
#include <termio.h>
#include <termios.h>
//#include <LEDA/basic.h>

#include "interface.h"

extern Interface interface;
extern int quitting;


void print_user_commands (void)
{
  printf ("\n USER COMMANDS:\n");
  printf ("  d <int> = dash <force>\n");
  printf ("  k <int> = kick <force>\n");
  printf ("  s       = read sensors\n");
  printf ("  t <int> = turn <force>\n");
  printf ("  h = this list\n");
  printf ("  r = reset\n");
  printf ("  q = QUIT\n\n");
  printf ("  P = PAUSE\n");
  printf ("  p = TOGGLE PRINT SENSOR DATA\n");
  
  printf ("  A = only sensors ON, all the rest OFF\n");
  printf ("  B = Lookaround and Base ON; the rest OFF\n");
  printf ("  C = Lookaround, Movetoball, Base ON\n");
  printf ("  D = Turntogoal, Kicktogoal, Base, Kick ON\n");
  printf ("  E = ALL ON\n");
  printf ("  H = this list\n");
  printf ("  R = reset\n");
  printf ("  Q = QUIT\n\n");
}


// This function is a thread. It reads keyboard and changes control software
// state with interface.change_control_system_state().
void *read_user_command (void *arg)
{
#ifndef NO_UI
     struct termios term;
     char inputch;

     char *sending_buffer = new char[512];

     int p;
          
     if (ioctl(0, TCGETS, &term) == -1) {
          
          perror("ioctl(0, TCGETS, ..)");
          return NULL;
     }
     
//     printf("ICANON previously:  %s\n", (term.c_lflag & ICANON) ? "ON" : "OFF");
//     printf("MIN previosly:      %i\n", term.c_cc[VMIN]);
//     printf("TIME previosly:     %i\n", term.c_cc[VTIME]);
     
     term.c_lflag &= ~ICANON;
     term.c_cc[VMIN] = 1;
     
     if (ioctl(0, TCSETS, &term) == -1) {

          perror("ioctl(0, TCSETS, ..)");
          return NULL;
     }
     
     while(1){
          
          // wait for new keypress and store it to inputch
          inputch = getchar();
          pthread_testcancel();
                   
          switch (inputch)
               {
/*               case '1': 
                   assert(0);
                   exit(1);
                   break;*/
               case 'y':
                    strcpy(sending_buffer,"(dash 100)");
                    interface.command_send_textbuffer(sending_buffer);
                    printf("Dash command sent!\n");
                    break;
               case 'h':
                    strcpy(sending_buffer, "(dash -30)");
                    interface.command_send_textbuffer(sending_buffer);
                    printf("Dash command sent!\n");
                    break;
               case 'g':
                    strcpy(sending_buffer, "(turn -30)");
                    interface.command_send_textbuffer(sending_buffer);
                    printf("Turn command sent!\n");
                    break;
               case 'j':
                    strcpy(sending_buffer, "(turn 30)");
                    interface.command_send_textbuffer(sending_buffer);
                    printf("Turn command sent!\n");
                    break;
               case ' ':
                    strcpy(sending_buffer, "(kick 100 0)");
                    interface.command_send_textbuffer(sending_buffer);
                    printf("Kick command sent!\n");
                    break;
               case ',':
                    strcpy(sending_buffer, "(kick 30 0)");
                    interface.command_send_textbuffer(sending_buffer);
                    break;
                    
               case 'd':
                    strcpy(sending_buffer,"(dash ");
                    // sending_buffer = "(dash ";
                    inputch = getchar();
                    while(inputch >= '0' && inputch <= '9'|| inputch == '-'){
                         p = strlen(sending_buffer);
                         sending_buffer[p] = inputch;
                         sending_buffer[p+1] = 0;
                         // sending_buffer += inputch;
                         cerr << "Waiting new dash command, it is now: " << sending_buffer << endl;
                         inputch = getchar();
                    }
                    
                    p = strlen(sending_buffer);
                    strcpy(&(sending_buffer[p]),")");
                    
                    // sending_buffer += ')';
                    cerr << "Dash sent" << endl;
                    interface.command_send_textbuffer(sending_buffer);
                    break;
               case 'k':
                    strcpy(sending_buffer,"(kick ");
                    // sending_buffer = "(kick ";
                    inputch = getchar();
                    while(inputch >= '0' && inputch <= '9'){
                         p = strlen(sending_buffer);
                         sending_buffer[p] = inputch;
                         sending_buffer[p+1] = 0;
                         // sending_buffer += inputch;
                         inputch = getchar();
                    }
                    p = strlen(sending_buffer);
                    strcpy(&(sending_buffer[p])," 0)");
                    // sending_buffer += " 0)";
                    cerr << "Kick sent" << endl;
                    interface.command_send_textbuffer(sending_buffer);
                    break;
               
      
               case 't':
                    strcpy(sending_buffer, "(turn ");
                    inputch = getchar();
                    while(inputch >= '0' && inputch <= '9' || inputch == '-'){
                         p = strlen(sending_buffer);
                         sending_buffer[p] = inputch;
                         sending_buffer[p+1] = 0;
                         cerr << "Waiting new turn command, it is now: " << sending_buffer << endl;
                         inputch = getchar();
                    }
                    p = strlen(sending_buffer);
                    strcpy(&(sending_buffer[p]),")");
                    cerr << "turn sent" << endl;
                    interface.command_send_textbuffer(sending_buffer);
                    break;
                    
               case 'A':
                    interface.change_control_system_state(SENSORS_ON);
                    printf("Only sensors ON!\n");
                    break;
               
               case 'B':
                    interface.change_control_system_state(LOOKAROUND_ON);
                    printf("Lookaround and Base ON!\n");
                    break;
                    
               case 'C':
                    interface.change_control_system_state(BALL_BEHAVIORS_ON);
                    printf("Ball behaviors Lookaround, Movetoball and Base ON!\n");
                    break;
                    
               case 'D':
                    interface.change_control_system_state(GOAL_BEHAVIORS_ON);
                    printf("Goal behaviors Turntogoal, Kicktogoal and Base, Kick ON!\n");
                    break;
                    
               case 'E':
                    interface.change_control_system_state( ALL_ON);
                    printf("ALL ON!\n");
                    break;
                    

               case 'H':
                    print_user_commands ();
                    break;
                    
               case 'r':      
               case 'R':
                    interface.change_control_system_state(RESET_SOCCER);
                    printf("Resetting...\n");
                    // call reset() 
                    break;
                    
               case 'q':
               case 'Q':
                    interface.change_control_system_state(QUIT_SOCCER);
                    return NULL;
                    break;
                    
               case 'P': 
                    interface.change_control_system_state(PAUSE_SOCCER);
                    break;
               case 'p': interface.sensor_data_prints();
                   break;
               default:
                    break;
     
               }
     }
     
//     return state;
     if(Cons2::debug_level_exit()) cerr << "Leaving keyboard_read_thread" << endl;
#endif
     return 0;
}
     
/* end of file */







