// -*- mode:C++ -*-
// file    : v_comm.h
// includes: class declaration for the v_comm
// 
// return values: 1 = sucess, 0 = failure

#ifndef _V_COMM_H
#define _V_COMM_H 1

#include "v_decls.h"

class v_comm {
public:
     v_comm();
     ~v_comm ();

     // visualizer receives first message type (init, request, or quit) and
     // then decides based on the type what to do next

     int rcv_msg_type ();
     
     // producer sends init msg to the visualizer with this method

     int send_init(opfstream& out, float min_x, float max_x, 
                   float min_y, float max_y,
                   float scaling, char *title);
     
     int rcv_init_body (float& min_x, float& max_x, 
                        float& min_y, float& max_y,
                        float& scaling, char title[V_MAX_TITLE_LEN]);

     // visualizer receives init msg with this method

     int rcv_init (float& min_x, float& max_x, 
                   float& min_y, float& max_y,
                   float& scaling, char title[V_MAX_TITLE_LEN]);

     // producer sends requests with this method

     int send_req (opfstream& out, int objn, v_obj_type type, 
                   float x, float y, float dir, float dim, 
                   char *name, v_color clr);
     
     int rcv_req_body (int& objn, v_obj_type& type, float& x, float& y,
                       float& dir, float& dim, char name[V_MAX_NAME_LEN], 
                       v_color& clr);
     
     // visualizer receives requests with this method

     int rcv_req (int& objn, v_obj_type& type, float& x, float& y,
                  float& dir, float& dim, char name[V_MAX_NAME_LEN],
                  v_color& clr);
     
     // producer quits the visualizer with this method

     void send_quit (opfstream& out);

protected:
};


#endif

/* end of file */







