// -*- mode:C++ -*-
// file    : v_drawer.h
// includes: class declaration for the v_drawer - the main 
//           class of the visualizer
// 

#ifndef _V_DRAWER_H
#define _V_DRAWER_H 1

#include <sys/types.h>
#include <time.h>
#include "v_obj.h"
#include "v_comm.h"

class v_drawer {
public:
     v_drawer();
     ~v_drawer ();

     void update_freq ();

     int receive_and_draw();
     
     void winsize(float min_x, float max_x, float min_y, float max_y,
                  float scaling, float& width, float& height);

     void draw_text(char *txt) 
          {
               win->draw_ctext(0, freq_y, string(txt));
          }

protected:
     v_comm comm;             // communication (protocol) object
     window* win;             // LEDA window
     v_obj requests[V_NOBJS]; // new requests for dynamic objects
     v_obj drawn[V_NOBJS];    // already drawn dynamic objects
     v_obj statobj;           // new request for a static object
     struct timeval prev_t;   // time at previous freq. calculation
     int nexecs;              // executions since prev. freq. calc.
     float freq;              // calculated frequency
     char freq_str[20];       // freq. string currently on the screen
     float freq_x;            // position of the frequency string
     float freq_y;
};

#endif _V_DRAWER_H

/* end of file */







