// -*- mode:C++ -*-
// file    : v_obj.h
// includes: class declaration for visualized objects


#ifndef _V_OBJ_H
#define _V_OBJ_H 1

#include <LEDA/basic.h>
#include <LEDA/string.h>
#include <LEDA/window.h>
#include "v_decls.h"

class v_obj {
public:
  v_obj();
  ~v_obj ();
  v_obj& operator=(const v_obj&);
  void set(bool oactive, v_obj_type otype, float ox, float oy,
	   float odir, float odim, char *oname, v_color oclr);
  void get(bool& oactive, v_obj_type& otype, float& ox, float& oy,
	   float& odir, float& odim, char *oname, v_color& oclr);
  void set_name(char *to);
  void get_name(char *got);
  bool is_active() {return active;}
  void deactivate() {active = false;}
  void activate() {active = true;}
  void draw(window* win);
  friend ostream& operator<<(ostream& s, v_obj& v);

protected:
  bool active;
  v_obj_type type;
  float x;       
  float y;       
  float dir;   // circular: don't care
  float dim;   // circular: radius; segment: length
  char name[V_MAX_NAME_LEN]; // string name;
  v_color clr;
};

#endif _V_OBJ_H

/* end of file */







