// file    : v_producer.cc
// includes: functions for the v_producer class

#include <math.h>
#include "v_producer.h"


v_producer::v_producer (char* program_pipe,
                        float min_x, float max_x, 
                        float min_y, float max_y,
                        float scaling, char *title)
          :out(program_pipe)
{
     active = comm.send_init (out, min_x, max_x, min_y, max_y, scaling, title);
}


v_producer::~v_producer()
{
     ;
}


int v_producer::send_req(int objn, v_obj_type type, float x, float y,
                         float dir, float dim, char *name, v_color clr)
{
     if (!active)
          {
               cerr << "VISUALIZING ERROR: request sent before succesful initialization" << endl;
               return 0;
          }
     
     return comm.send_req (out, objn, type, x, y, dir, dim, name, clr);
}


int v_producer::quit()
{
     if (active) comm.send_quit(out);
     return 1;
}

/* end of file */

